// (c) copyright 2017-2019
// Wolfgang Scherr OE8WOZ
//
// all rights reserved
//
// No guarantees whatsoever.
// USE AT YOUR OWN RISK!
//
#define DEBUG 0
#define VERSION "DEMO v0.1"

//###################################################################################################

// PLEASE READ:
//
// This software is written in the sense to be useful, but it may contain bugs or problems causing to damage your hardware (Arduino, Display, Transceiver).
// No guarantees or liability for this packet, you are YOURSELF responsible for compiling, uploading and using of this software.
// SAVE THE CALIBRATION DATA OF YOUR FT-817!!! See also here: http://www.ka7oei.com/ft817_meow.html   or here: http://f5bud.free.fr/817mem.php
//    - Turn the radio off.
//    - Press and hold the three A, B, C buttons and press the PWR button.
//    - To change to a different item turn the small SEL knob.
//    - Write all 76 values and keep your notes.
// If all understood, you made the data backup and if you agree to use this software at your own risk and for non-commercial purposes,
//      comment the next #error line and continue. If not, please do not continue and delete this package.
// 
// BITTE LESEN:
//
// Diese Software wurde im Sinne nützlich zu sein geschrieben, aber sie kann Fehler oder Probleme beinhalten die Ihre Hardware beschädigen kann (Arduino, Display, Funkgerät).
// Es werden keinerlei Garantien oder Sicherheiten für dieses Paket übernommen, sie sind für das Kompilieren, Aufspielen und Nutzen der Software SELBST verantwortlich.
// SICHERN SIE DIE KALIBRATIONSDATEN IHRES FT-817!!! Siehe auch hier: http://www.ka7oei.com/ft817_meow.html oder hier: http://f5bud.free.fr/817mem.php
//    - Gerät ausschalten.
//    - A, B, C Tasten drücken und halten, dann PWR drücken.
//    - Einträge sieht man durch das Drehen des kleinen SEL Knopfs.
//    - Schreiben sie alle 76 Werte auf und heben sie ihre Notizen gut auf.
// Wenn alles verstanden wurde, sie die Sicherung gemacht haben und wenn sie akzeptieren, diese Software auf eigenes Risiko und für nichtkommerzielle
//      Zwecke zu nutzen, kommentieren sie die nächste #error Zeile und fahren sie fort. Ansonsten bitte nicht weitermachen und löschen sie das Paket.

#error "!! please read the above text in this file first !! / !! bitte lesen Sie zuerst den obigen Text in dieser Datei !!"

//###################################################################################################

// CONNECTIVITY:
// =============
//  
//       Arduino MEGA 2560 Board (any version, pinout e.g. taken from here: 
//       http://forum.arduino.cc/index.php?action=dlattach;topic=146511.0;attach=90705)
//  
//       additionally Arduino RX/TX (!), TFT LCD (*), FT-817 (+), GPS (&), GSM (~)
//       band signaling and VHF/UHF-signaling (&) connectivity shown (all as a proposal only):
//
//
//                                                             GPS
//                                                             |         
//                                                             #--------------------------------------------.
//                                                             |                                            |
//                                                             |     FT817                                  |
//                                                             |     |                                      |
//                                  * *                        #-# #-#                                      |
//                          * * * * D D                        | | | |                                      |
//                          S S S S 1 0                        | | | |                                      |
//                          D D D D / /  * * * * * * ! !   ~ ~ &(&)+ +                                      |
//                          C D D S X Y  D D D D D D T R   R T R(T)R T                                      |
//                          K O I S P M  7 6 5 4 3 2 X X   X X X(X)X X                                      |
//       -------------------------------------------------------------------------------                    |
//       |          # # # # # # # # # #  # # # # # # # #   # # # # # # # #             |                    |
//       |          S S A G 1 1 1 1 0 0  0 0 0 0 0 0 0 0   1 1 1 1 1 1 2 2    5V# #5V  | % -       +5V------#
//       |          C D R N 3 2 1 0 9 8  7 6 5 4 3 2 1 0   4 5 6 7 8 9 0 1    22# #23  | % ZF-70   ZF-2     |
//       |          L A E D                          T R   T R T R T R S S    24# #25  | % -       KEY      |
//       |              F                            X X   X X X X X X D C    26# #27  | % RF-1G   RF-2G    |
//       |                                                 3 3 2 2 1 1 A L    28# #29  | % RF-3G   RF-5G    |
//       |=====                                                               30# #31  | % RF-10G  RF-24G   |
//       |    =                                                               32# #33  | % RF-47G  RF-76G   |
//       |USB =                                                               34# #35  | % RF-122G RF-134G  |
//       |    =                                                               36# #37  | % RF-240G -        |
//       |=====                                                               38# #39  |                    |
//       |                                                                    40# #41  |                    |
//       |                                                                    42# #43  |                    |
//       |                                                                    44# #45  |                    |
//       |                                                                    46# #47  |                    |
//       |                                                                    48# #49  |                    |
//       |                    R 3   G G V                        A A A A A A  50# #51  |                    |
//       |========        n 5 E V 5 N N I    A A A A A A A A A A 1 1 1 1 1 1  52# #53  |                    |
//       |DC-CON =        c V S 3 V D D N    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 GND# #GND | % -       GND------#
//       |========        # # # # # # # #    # # # # # # # # # # # # # # # #           |
//       -------------------------------------------------------------------------------
//                                           * * * * *
//                                           L L L L L
//                                           C C C C C
//                                           D D D D D
//                                           R W C C R
//                                           D R D S E
//                                               / / S
//                                               Y X
//                                               P M
//
//
//       FT-817(ND) ACC connector:
//
//           __   __
//          /  `-´  \     BAND       TX
//         / #  #  # \    DATA  ALC  INH
//        |           |
//        | #  #    # |   GND  TX      RX   <--- we need this three here !
//        |           |
//         \  #   #  /      13V    PTT
//          '_______'       
//
//
//
//       FT-817(ND) KEY connector:
//
//
//      KEY        GND        _____________
//        _     _____________|
//       / \_/||             |
//      |   _ ||             |
//       \_/ \||_____________|
//                           |_____________
//
//
//  Arduino     FT-817          FT-817        Note
//              ACC             KEY           
//  ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//  TX          RX                            Push-Pull, you may add some ~20 Ohms series resistor
//  RX          TX                            Push-Pull, you may add some ~20 Ohms series resistor
//  GND         GND                           Common ground
//  ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//  Pin#13                      KEY           Open drain (additional pull-up not required)
//  GND                         GND           Common ground
//  ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//
//
//  Be aware that RX/TX above is shared with USB serial connection, so disconnect FT-817 when
//  performing firmware upgrades or if you do development with USB connected to Aduino.
//
//###################################################################################################


// SOFTWARE RESET
void(* soft_reset) (void) = 0; //declare reset function at address 0, watchdog trick seems not to work with MEGA2560

// any EMEA GPS module

#include <TinyGPS.h>

TinyGPS gps; // create gps object 
#define GPS_Serial Serial2

// FT-817 transceiver

#include <YaesuControl.h>
YaesuControl ft817 = YaesuControl();

// Additonal pin definitions
#define FT817_KEY 25

// TOUCHSCREEN

#include <TouchScreen.h>

// Display assumed to be 320x240 pixel
#define YP A2  // must be an analog pin, use "An" notation!
#define XM A3  // must be an analog pin, use "An" notation!
#define YM 8   // can be a digital pin
#define XP 9   // can be a digital pin

#define TS_MINX 130
#define TS_MAXX 905
#define TS_MINY 75
#define TS_MAXY 930
TouchScreen ts = TouchScreen(XP, YP, XM, YM, 300);

#define MINPRESSURE 50
#define MAXPRESSURE 500

// LCD DISPLAY

#include <Adafruit_GFX.h>  // Core graphics library

#include <MCUFRIEND_kbv.h> // Hardware-specific library
MCUFRIEND_kbv tft;

#define BLACK   0x0000
#define DARKGRAY 0x1861
#define GRAY     0x39E7
#define LITEGRAY 0x7BEF
#define BLUE    0x001F
#define GREEN   0x07E0
#define RED     0xF800
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define ORANGE  0xFAE0
#define YELLOW  0xFFE0
#define WHITE   0xFFFF

#define BOXSIZE 40
#define PENRADIUS 3

#include <Fonts/FreeMono9pt7b.h>
#include <Fonts/FreeSerif9pt7b.h>

//###################################################################################################

// =================================================
// Subroutines the Arduino SETUP/LOOP can use
// =================================================

// --------------------------------------------
// handle touchscreen in an 80px/80px grid and return the button ID (if pressed)
//
//  0.......479
//  1  2  3  4  5  6    0
//  7  8  9 10 11 12    .
// 13 14 15 16 17 18    .
// 19 20 21 22 23 24  319
// --------------------------------------------
int16_t touch() {
  TSPoint pm;
  int16_t item=0;
  TSPoint p = ts.getPoint();
  p = ts.getPoint();

  // if sharing pins, you'll need to fix the directions of the touchscreen pins afterwards
  pinMode(XM, OUTPUT);
  pinMode(YP, OUTPUT);

  // we have some minimum pressure we consider 'valid'
  // pressure of 0 means no touch at all.
  if ((p.z > MINPRESSURE) && (p.z < MAXPRESSURE)) {
    // scale from 0->1023 to tft.width
    pm.x = map(p.x, TS_MINX, TS_MAXX, tft.width(), 0);
    pm.y = map(p.y, TS_MINY, TS_MAXY, tft.height(), 0);
    
    if (pm.x>tft.width()-1) pm.x=tft.width()-1;
    if (pm.y>tft.height()-1) pm.x=tft.height()-1;

    // we get something between 1...12
    item = (pm.x/80)+(pm.y/80)*(tft.width()/80)+1;

  #if DEBUG==1
    // we might need this details if something goes wrong...
    Serial.print("X: ");Serial.print(p.x);Serial.print(" Y: ");Serial.println(p.y);
    Serial.print("MX: ");Serial.print(pm.x);Serial.print(" MY: ");Serial.println(pm.y);
    Serial.print("Z: ");Serial.println(p.z);
    Serial.print("T: ");Serial.println(item);
  #endif

  } else {
    // nothing pressed
    item=0;
  }
  return item;
}

// --------------------------------------------
// basic button generation
// we use the same 80px/80px for the item
//
//  0.......479
//  1  2  3  4  5  6    0
//  7  8  9 10 11 12    .
// 13 14 15 16 17 18    .
// 19 20 21 22 23 24  319
// --------------------------------------------

static void button(int16_t item, const char *txt1, const char *txt2, const char *txt3, uint8_t pos, uint8_t init) {
  #ifdef EEP_STRINGS
    char buf[8];           // must be large enough!  
  #else
    const char *buf;
  #endif
  int16_t x, y;
  int16_t x1,y1;
  uint16_t w,h;

  // from item number to coordinate
  --item;
  x = (item%6)*80;
  y = (item/6)*80;

  // we are asked to repaint the background
  // should not be used if a button is re-drawn with a new selection
  if (init==1) {
    tft.fillRoundRect(x+2,y+2,62,62,8,LITEGRAY);
    tft.fillRoundRect(x,y,62,62,8,GRAY);
    tft.fillRoundRect(x+2,y+2,58,58,6,DARKGRAY);
  }

  tft.setFont(&FreeSerif9pt7b);
  tft.setTextSize(1);

  // large position number indicates it is not a selection button
  if (pos>=16) {
    tft.fillRect(x+4,y+8,54,15,GRAY);
    tft.fillRoundRect(x+4,y+4,54,54,6,GRAY);
    tft.setTextColor(WHITE);
  }

  // we have a selection button highlighting the first line
  if (pos==1) {
    tft.fillRect(x+4,y+8,54,15,ORANGE);
    tft.setTextColor(WHITE);  
  } else if (pos<16) {
    tft.fillRect(x+4,y+8,54,15,DARKGRAY);
    tft.setTextColor(GRAY);  
  }
  #ifdef EEP_STRINGS
    strcpy_P (buf, txt1);
  #else
    buf=txt1;
  #endif
  tft.getTextBounds((char *)buf,0,0,&x1,&y1,&w,&h);
  tft.setCursor(x+(60-w+1)/2, y+20);
  tft.print(buf);

  // allow to draw 2nd/3rd text line of a non-selection
  // button in a different colour than white (green or 
  // orange - e.g. to show valid/invalid or enabled/disabled)
  // if (pos==16) tft.setTextColor(WHITE); --> already the case
  if (pos==17) tft.setTextColor(GREEN);
  if (pos==18) tft.setTextColor(ORANGE);

  // we have a selection button highlighting the second line
  if (pos==2) {
    tft.fillRect(x+4,y+23,54,15,ORANGE);
    tft.setTextColor(WHITE);  
  } else if (pos<16) {
    tft.fillRect(x+4,y+23,54,15,DARKGRAY);
    tft.setTextColor(GRAY);  
  }
  #ifdef EEP_STRINGS
    strcpy_P (buf, txt2);
  #else
    buf=txt2;
  #endif
  tft.getTextBounds((char *)buf,0,0,&x1,&y1,&w,&h);
  tft.setCursor(x+(60-w+1)/2, y+35);
  tft.print(buf);

  // we have a selection button highlighting the third line
  if (pos==3) {
    tft.fillRect(x+4,y+38,54,15,ORANGE);
    tft.setTextColor(WHITE);  
  } else if (pos<16) {
    tft.fillRect(x+4,y+38,54,15,DARKGRAY);
    tft.setTextColor(GRAY);  
  }
  #ifdef EEP_STRINGS
    strcpy_P (buf, txt3);
  #else
    buf=txt3;
  #endif
  tft.getTextBounds((char *)buf,0,0,&x1,&y1,&w,&h);
  tft.setCursor(x+(60-w+1)/2, y+50);
  tft.print(buf);
}

// --------------------------------------------
// this will clean the display and
// dump the relevant FT-817ND EEP content
// twice for a photograph
// --------------------------------------------
void dump_eep() {
  int i;
  char c[10];
  char s[256];

  tft.setFont(0);
  tft.fillScreen(BLACK);
  tft.setCursor(0, 2);
  tft.setTextSize(2);
  tft.setTextColor(RED);
  tft.print(" FT-81xND EEP-DATA ("); 
  tft.setTextColor(WHITE);

  if (ft817.getConfig(c)<0) soft_reset();
  for(i=0;i<9;i++) {
      sprintf(s,"%02X",(uint16_t)(c[i]&0xff));
      tft.print(s);
  }
  tft.setTextColor(RED);
  tft.println(")"); 

  tft.setTextColor(WHITE);
  tft.setTextSize(1);

  unsigned long oldval=ft817.getEEP(0)&0x0FF;
  for(i=0x00;i<=0xFF;++i) {
    int32_t val1=ft817.getEEP(i);
    int32_t val2=ft817.getEEP(i);

    if ((i&0x0f)==0) {
      tft.println(); 
      sprintf(s,"           %02x: ",i);
      tft.print(s);
    }

    if ((val1==val2) && ((val1&0x0FF)==oldval) && (val1!=0x10000L)) {
      sprintf(s,"%02X ",(uint16_t)(val1&0xff));
    } else {
      sprintf(s,"-- "); soft_reset();
    }
    tft.print(s);
    oldval=(val1>>8)&0x0FF;
    if ((i&0x0f)==7) {
      tft.print(" ");
    }
  }
  tft.println(); 

  tft.setFont(&FreeMono9pt7b);
  oldval=ft817.getEEP(0)&0x0FF;
  for(i=0x00;i<=0x5F;++i) {
    unsigned long val1=ft817.getEEP(i);
    unsigned long val2=ft817.getEEP(i);
    char s[256];

    if ((i&0x0f)==0) {
      tft.println(); 
      sprintf(s,"   %02x: ",i);
      tft.print(s);
    }
    if ((val1==val2) && ((val1&0x0FF)==oldval)) {
      sprintf(s,"%02X",(uint16_t)(val1&0xff));
    } else {
      sprintf(s,"--"); soft_reset();
    }
    tft.print(s);
    oldval=(val1>>8)&0x0FF;
    if ((i&0x0f)==7) {
      tft.print(" ");
    }
  }
  tft.println(); 

  tft.setTextColor(YELLOW);  
  tft.println("  please photograph / bitte fotografieren"); 
  tft.setTextColor(ORANGE);  
  tft.println("also FT817 serial / auch FT817 Seriennummer");   
}

//###################################################################################################

// =================================================
// Arduino SETUP, called at power-up
// =================================================

void setup(void) {
  // we set the pin high (LCD reset)
  pinMode(A4, INPUT_PULLUP);

  // we set the pin as pull-up input and switch to output/low only (KEY, low active, 5V MAX!!!!)
  pinMode(FT817_KEY, INPUT_PULLUP);
  digitalWrite(FT817_KEY, HIGH);

  // Serial for debug, etc.
  Serial.begin(115200);

  // reset and identify display
  tft.reset();
  uint16_t identifier = tft.readID();

  Serial.print("ID: ");
  Serial.println(identifier,HEX);

  // check your supported MCUFRIEND_kbv.cpp display ID here
  if (identifier == 0x8230) {
    // --> UC8230 LCD type
    // ok, this is one we added and should work, continue
  } else if (identifier == 0x9486) {
    // --> ILI9486 LCD type
    // ok, this should work too, continue
  } else {
    // display not added, stop to avoid any issues
    while(1) {};
  }

  // GPS serial init
  GPS_Serial.begin(9600);

  // setup display mode and clean it up
  tft.begin(identifier);
  tft.setRotation(3);
  tft.fillScreen(BLACK);
  tft.println();tft.println();
  tft.print("Baudrate used by display to PC USB: ");
  tft.println(119200);
  tft.println();
  tft.print("Baudrate used by display to FT-817: ");
  tft.println(FT817_BAUD48);
  tft.println();tft.println();
  tft.println("Please connect display and switch on transceiver.");

  // =====================================================

  // FT817 serial init, wait to get ready
  ft817.begin(FT817_BAUD48);
  while (ft817.init()) {};

  // =====================================================
  uint32_t f;
  int16_t m;
  int16_t p;
  int8_t b;

  // clear screen and show main GUI now
  tft.fillScreen(BLACK);

  tft.setFont(0);
  tft.setCursor(0, 5);

  tft.setTextSize(2);
  tft.setTextColor(YELLOW);
  tft.println("YaesuControl Library Test");

  tft.setTextSize(1);
  tft.setTextColor(WHITE);
  //tft.println();
  //tft.println("Connection --> OK");

  tft.println();
  tft.println("==========================================================");
  tft.println("Set/Get Frequency and Mode");
  tft.println();
  delay(100);

  ft817.setMode(FT817_MODE_FM);
  ft817.setFreq(145500000L);
  m=ft817.getFreqMode(&f);
  tft.print("Mode: ");
  tft.print(m);
  tft.print(", Freq: ");
  tft.print(f);
  tft.print(" --> ");
  if ((m==FT817_MODE_FM)&&(f==145500000L)) tft.println("OK");
  else { tft.println("FAIL"); soft_reset(); }
  delay(1000);

  ft817.setMode(FT817_MODE_USB);
  ft817.setFreq(432500000L);
  m=ft817.getFreqMode(&f);
  tft.print("Mode: ");
  tft.print(m);
  tft.print(", Freq: ");
  tft.print(f);
  tft.print(" --> ");
  if ((m==FT817_MODE_USB)&&(f==432500000L)) tft.println("OK");
  else { tft.println("FAIL"); soft_reset(); }
  delay(1000);

  ft817.setFreq(144200000L);
  m=ft817.getFreqMode(&f);
  tft.print("Mode: ");
  tft.print(m);
  tft.print(", Freq: ");
  tft.print(f);
  tft.print(" --> ");
  if ((m==FT817_MODE_USB)&&(f==144200000L)) tft.println("OK");
  else { tft.println("FAIL"); soft_reset(); }
  delay(1000);

  ft817.setMode(FT817_MODE_CW);
  m=ft817.getFreqMode(&f);
  tft.print("Mode: ");
  tft.print(m);
  tft.print(", Freq: ");
  tft.print(f);
  tft.print(" --> ");
  if ((m==FT817_MODE_CW)&&(f==144200700L)) tft.println("OK");
  else { tft.println("FAIL"); soft_reset(); }
  delay(1000);

  tft.println();
  tft.println("==========================================================");
  tft.println("Set/Get PWR");
  tft.println();
  delay(100);

  tft.print("Pwr: ");
  ft817.setPwr(0);
  b=ft817.getPwr();
  tft.print(b);
  tft.print(" ");
  delay(1000);
  if (b==0) {
    ft817.setPwr(1);
    b=ft817.getPwr();
    tft.print(b);
    tft.print(" ");  
    delay(1000);
    if (b==1) {
      ft817.setPwr(2);
      b=ft817.getPwr();
      tft.print(b);
      tft.print(" ");   
      delay(1000);
      if (b==2) {
        ft817.setPwr(3);
        b=ft817.getPwr();
        tft.print(b);
        delay(1000);
      }
    }
  }
  if (b==3) tft.println(" --> OK");
  else tft.println(" --> FAIL");

  tft.println();
  tft.println("==========================================================");
  tft.println("Set/Get Front/Back Port");
  tft.println();
  delay(100);

  tft.print("Reverse port: ");
  ft817.setPort(1);
  b=ft817.getPort();
  tft.print(b);
  tft.print(" ");
  delay(1000);
  if (b==1) tft.println(" --> OK");
  else tft.println(" --> FAIL");

  tft.print("Front port: ");
  ft817.setPort(0);
  b=ft817.getPort();
  tft.print(b);
  tft.print(" ");
  delay(1000);
  if (b==0) tft.println(" --> OK");
  else tft.println(" --> FAIL");

  tft.println();
  tft.println("==========================================================");
  tft.println("Set/Get PTT (and status)");
  tft.println();
  delay(100);

  p=ft817.getPTT();
  tft.print("check PTT: ");
  tft.print(p);
  tft.print(" --> ");
  if (p==0) tft.println("OK");
  else { tft.println("FAIL"); soft_reset(); }

  m=ft817.getRxStatus();
  tft.print("RX status: ");
  tft.print(m);
  m=ft817.getTxStatus();
  tft.print(" --> ");
  if (m==0xFF) tft.println("OK");
  else { tft.println("FAIL"); soft_reset(); }

  p=ft817.setPTT(1);
  delay(100);

  tft.print("set, PTT: ");
  tft.print(p);
  tft.print(" --> ");
  if (p==0) tft.println("OK");
  else { tft.println("FAIL"); soft_reset(); }

  p=ft817.getPTT();
  tft.print("check PTT: ");
  tft.print(p);
  tft.print(" --> ");
  if (p==1) tft.println("OK");
  else { tft.println("FAIL"); soft_reset(); }

  m=ft817.getTxStatus();
  tft.print("TX status: ");
  tft.print(m);
  m=ft817.getRxStatus();
  tft.print(" --> ");
  if (m==0xFF) tft.println("OK");
  else { tft.println("FAIL"); soft_reset(); }

  p=ft817.setPTT(0);
  delay(200);

  tft.print("clr, PTT: ");
  tft.print(p);
  tft.print(" --> ");
  if (p==0) tft.println("OK");
  else { tft.println("FAIL"); soft_reset(); }

  p=ft817.getPTT();
  tft.print("check PTT: ");
  tft.print(p);
  tft.print(" --> ");
  if (p==0) tft.println("OK");
  else { tft.println("FAIL"); soft_reset(); }

  m=ft817.getRxStatus();
  tft.print("RX status: ");
  tft.print(m);
  m=ft817.getTxStatus();
  tft.print(" --> ");
  if (m==0xFF) tft.println("OK");
  else { tft.println("FAIL"); soft_reset(); }

  tft.print("Wait PTT pressed: ");
  do {
    p=ft817.getPTT();
    delay(100);
  } while (p!=1);
  tft.print(p);
  tft.print(" --> ");
  if (p==1) tft.println("OK");
  else { tft.println("FAIL"); soft_reset(); }

  m=ft817.getTxStatus();
  tft.print("TX status: ");
  tft.print(m);
  m=ft817.getRxStatus();
  tft.print(" --> ");
  if (m==0xFF) tft.println("OK");
  else { tft.println("FAIL"); soft_reset(); }

  tft.print("Wait PTT released: ");
  do {
    p=ft817.getPTT();
    delay(100);
  } while (p!=0);
  tft.print(p);
  tft.print(" --> ");
  if (p==0) tft.println("OK");
  else { tft.println("FAIL"); soft_reset(); }

  m=ft817.getRxStatus();
  tft.print("RX status: ");
  tft.print(m);
  m=ft817.getTxStatus();
  tft.print(" --> ");
  if (m==0xFF) tft.println("OK");
  else { tft.println("FAIL"); soft_reset(); }

  tft.println();
  tft.print("Press touchscreen for EEP readout.");

  // =====================================================
  while (!touch()) {};

  // clear screen and show main GUI now
  tft.fillScreen(BLACK);

  tft.setFont(0);
  tft.setCursor(0, 5);

  dump_eep();
  while (!touch()) {};

  delay(2000);
}

//###################################################################################################

// =================================================
// Arduino LOOP, continuously called
// =================================================

void loop()
{
  delay(250);

  // here for example we just do a re-init to check it is there...
  if (ft817.init()) soft_reset();
  // on any issue with the FT817, don't continue
  // sending commands but immediately reset firmware !
}
